﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Design;
using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Tsi1.DataLayer
{
    public class DesignTimeDbContextFactory : IDesignTimeDbContextFactory<Tsi1Context>
    {
        public Tsi1Context CreateDbContext(string[] args)
        {
            IConfigurationRoot configuration = new ConfigurationBuilder()
                .SetBasePath(Directory.GetCurrentDirectory())
                .AddJsonFile(@Directory.GetCurrentDirectory() + "/../Tsi1.Api/appsettings.json")
                .Build();

            var isElasticCloud = bool.Parse(configuration.GetSection("IsElasticCloud").Value);
            var databaseSection = isElasticCloud ? "PostgreSqlCloud" : "PostgreSql";

            var connectionString = configuration.GetConnectionString(databaseSection);
            var builder = new DbContextOptionsBuilder<Tsi1Context>();
            builder.UseNpgsql(connectionString);

            return new Tsi1Context(builder.Options);
        }
    }
}
